#pragma once

#include "main.h"

enum DIRECTION
{
	UP = 0,
	DOWN,
	LEFT,
	RIGHT
};

struct Mouse
{
	unsigned int PosX;
	unsigned int PosY;
};

struct Node
{
	unsigned int PosX;
	unsigned int PosY;
};

class Game :
	public AppState
{
public:
	Game(void);
	~Game(void);

	bool OnInit(unsigned int length, unsigned int interval);
	void OnUpdate();

	void OnEvent(SDL_Event Event);

	void OnDraw();

	void EatMouse();
	void PlaceMouse();

private:
	unsigned int		mLastTicks;
	unsigned int		mInterval;

	DIRECTION			mNewDirection;
	DIRECTION			mDirection;

	SDL_Surface*		mSnakeSkin;

	std::vector<Node>	mSnake;

	bool				mGrowing;

	Mouse				mMouse;
	SDL_Surface*		mMouseSkin;

	int					mScore;
};
